import { Component, OnInit, ViewChild } from '@angular/core';
import { STColumn, STComponent } from '@delon/abc/st';
import { DatePipe, _HttpClient } from '@delon/theme';
import { differenceInCalendarDays } from 'date-fns';
import { DataService } from '../../../services/data.service';
import { BusitablePillarComponent } from '../pillar/pillar.component';

@Component({
  selector: 'app-datatable-mantable',
  templateUrl: './mantable.component.html',
  styleUrls: ['./mantable.component.less'],
  providers: [DatePipe]

})
export class DatatableMantableComponent implements OnInit {
  @ViewChild('pillar') private readonly pillar!: BusitablePillarComponent;
  @ViewChild('st') private readonly st!: STComponent;
  type = 1;
  mode = 'year';
  date: any = null;
  defineDate = [];
  time: any = ['2022-01-01 00:00:00']
  dateFormat = 'yyyy';
  today = new Date();
  dateNext: any = null;
  modeNext = 'year';
  chartData: any = {}
  timeNext: any = ['2022-01-01 00:00:00']
  flag = false;

  columns: STColumn[] = [
    { title: '部门', index: 'bm', className: 'text-center' },
    { title: '业务员', index: 'ywy', className: 'text-center' },
    { title: '合伙人数', index: 'hhrs', className: 'text-center' },
    { title: '客户数', index: 'khs', className: 'text-center' },
    { title: '客户活跃率', index: 'khhyl', className: 'text-center' },
    { title: '客户预存款', index: 'kfyck', className: 'text-center', type: 'widget', widget: { type: 'currency-chy', params: ({ record }) => ({ value: record.kfyck }) } },
    { title: '订单数', index: 'dds', className: 'text-center' },
    { title: '订单金额', index: 'ddje', className: 'text-center', type: 'widget', widget: { type: 'currency-chy', params: ({ record }) => ({ value: record.ddje }) } },
    { title: '业绩量', index: 'yjl', className: 'text-center' },
    { title: '附加费金额', index: 'fjfje', className: 'text-center', type: 'widget', widget: { type: 'currency-chy', params: ({ record }) => ({ value: record.fjfje }) } },
    { title: '平均附加费率', index: 'pjfjl', className: 'text-center' },
    { title: '已开票金额', index: 'ykpje', className: 'text-center', type: 'widget', widget: { type: 'currency-chy', params: ({ record }) => ({ value: record.ykpje }) } },
  ];
  /**
   * 查询参数
   */
   get reqParams() {
    if(this.mode === 'year') {
      this.type = 1
    } else if(this.mode === 'month') {
      this.type = 2
    } else if(this.mode === 'date') {
      this.type = 3
    } else {
      this.type = 4
    }
    let params: any = {
      time: this.time,
      type: this.type
     };
  
    delete params._$expand;
    return { ...params };
  }

  constructor(public service: DataService, private datePipe: DatePipe) { }
  ngOnInit(): void { }

  initData(){
    let type = 1
    if(this.mode === 'year') {
      type = 1
    } else if(this.mode === 'month') {
      type = 2
    }
    const params: any = {
      time: this.timeNext,
      type
     };
    this.service.request(this.service.$api_performanceReportHistogram, params).subscribe(res => {
      if (res) {
        this.chartData = res
        if(this.flag) {
          this.pillar.reRender()
        }
      }
    })
  }
  changeData(){
    if(this.mode === 'year') {
      this.dateFormat = 'yyyy'
    } else if(this.mode === 'month') {
      this.dateFormat = 'yyyy-MM'
    } else {
      this.dateFormat = 'yyyy-MM-dd'
    } 
  }
  onChange(result: any) {
    if(this.mode === 'year') {
      this.time = [this.datePipe.transform(this.date, 'yyyy') + '-01-01 00:00:00']
    } else if(this.mode === 'month') {
      this.time = [this.datePipe.transform(this.date, 'yyyy-MM') + '-01 00:00:00']
    } else if(this.mode === 'date') {
      this.time = [this.datePipe.transform(this.date, 'yyyy-MM-dd') + ' 00:00:00']
    } else{
      this.time = [this.datePipe.transform(this.defineDate[0], 'yyyy-MM-dd') + '00:00:00', this.datePipe.transform(this.defineDate[1], 'yyyy-MM-dd') + ' 00:00:00']
    }
    this.st.reload({ ...this.reqParams });
  }

  changeDataNext() {
    if(this.mode === 'year') {
      this.dateFormat = 'yyyy'
    } else if(this.mode === 'month') {
      this.dateFormat = 'yyyy-MM'
    }
  }
  onChangeNext(result: any) {
    if(result === null) {
      return
    }
    if(this.mode === 'year') {
      this.timeNext = [this.datePipe.transform(this.dateNext, 'yyyy') + '-01-01 00:00:00']
    } else if(this.mode === 'month') {
      this.timeNext = [this.datePipe.transform(this.dateNext, 'yyyy-MM') + '-01 00:00:00']
    }
    this.flag = true
    this.initData()
  }
  disabledDate = (current: Date): boolean =>
    // Can not select days before today and today
    differenceInCalendarDays(current, this.today) > 0;
  exportFun(){

  }

}
